﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Invoice;
using Microsoft.Practices.EnterpriseLibrary.Common;
using Microsoft.Practices.EnterpriseLibrary.Data;
using System.Data;
namespace VisualStudioTest
{
    /// <summary>
    /// Summary description for UnitTest1
    /// </summary>
    [TestClass]
    public class UnitTest1
    {
       
        public UnitTest1()
        {
            //
            // TODO: Add constructor logic here
            //
        }

        private TestContext testContextInstance;

        /// <summary>
        ///Gets or sets the test context which provides
        ///information about and functionality for the current test run.
        ///</summary>
        public TestContext TestContext
        {
            get
            {
                return testContextInstance;
            }
            set
            {
                testContextInstance = value;
            }
        }

        #region Additional test attributes
        //
        // You can use the following additional attributes as you write your tests:
        //
        // Use ClassInitialize to run code before running the first test in the class
        // [ClassInitialize()]
        // public static void MyClassInitialize(TestContext testContext) { }
        //
        // Use ClassCleanup to run code after all tests in a class have run
        // [ClassCleanup()]
        // public static void MyClassCleanup() { }
        //
        // Use TestInitialize to run code before running each test 
        // [TestInitialize()]
        // public void MyTestInitialize() { }
        //
        // Use TestCleanup to run code after each test has run
        // [TestCleanup()]
        // public void MyTestCleanup() { }
        //
        #endregion

        [TestMethod]
        public void TestMethod1()
        {
            clsInvoiceCalculation obj = new clsInvoiceCalculation();
            int intTotalCost = obj.CalculateCost(10, 20);
            Assert.AreEqual(200, intTotalCost);
            //
            // TODO: Add test logic	here
            //
        }
        [TestMethod]
        [DataSource("System.Data.SqlClient",
                    "Data Source=QUESTPON-SRIZE2;Initial Catalog=TestData;Integrated Security=True;Pooling=False", 
                    "TestProductData",
                    DataAccessMethod.Sequential)]
        public void TestMethodDataDriven()
        {
            int intNumberOfProducts = (int)TestContext.DataRow[0];
            int intPerProductCost = (int)TestContext.DataRow[1];
            int intExpectedValue = (int)TestContext.DataRow[2];
            clsInvoiceCalculation obj = new clsInvoiceCalculation();
            int intTotalCost = obj.CalculateCost(intNumberOfProducts, intPerProductCost);
            Assert.AreEqual(intExpectedValue, intTotalCost);
            
        }

        [TestMethod]
        [DataSource("System.Data.SqlClient",
                    "Data Source=QUESTPON-SRIZE2;Initial Catalog=TestData;Integrated Security=True;Pooling=False",
                    "Customer",
                    DataAccessMethod.Sequential)]
        public void TestCustomerInsert()
        {

            clsCustomer objCust = new clsCustomer();
            objCust.CustomerCode = TestContext.DataRow["CustomerCode"].ToString();
            objCust.CustomerName = TestContext.DataRow["CustomerName"].ToString();
            objCust.Add();
            
            DataSet objDs = getCustomer(objCust.CustomerCode);
            Assert.AreEqual(objDs.Tables[0].Rows[0]["CustomerCode"], objCust.CustomerCode);
            Assert.AreEqual(objDs.Tables[0].Rows[0]["CustomerName"], objCust.CustomerName);
        }
        private DataSet getCustomer(string strCustomerCode)
        {
            Database objDb = DatabaseFactory.CreateDatabase("MyConnection");
            return objDb.ExecuteDataSet(CommandType.Text, "Select CustomerCode,CustomerName from Customer where CustomerCode='" + strCustomerCode + "'");
        }
    }
}
